]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
Git 2.14
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
70c7ac22 45
be9d0a3a
HV
46die_if_unmatched ()
47{
48 if test "$1" = "#unmatched"
49 then
c4c02bf1 50 exit ${2:-1}
be9d0a3a
HV
51 fi
52}
53
88ce00c3
TK
54#
55# Print a submodule configuration setting
56#
57# $1 = submodule name
58# $2 = option name
59# $3 = default value
60#
61# Checks in the usual git-config places first (for overrides),
62# otherwise it falls back on .gitmodules. This allows you to
63# distribute project-wide defaults in .gitmodules, while still
64# customizing individual repositories if necessary. If the option is
65# not in .gitmodules either, print a default value.
66#
67get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
75 fi
76 printf '%s' "${value:-$default}"
77}
78
862ae6cd
RS
79isnumber()
80{
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82}
83
14111fc4
JK
84# Sanitize the local git environment for use within a submodule. We
85# can't simply use clear_local_git_env since we want to preserve some
86# of the settings from GIT_CONFIG_PARAMETERS.
87sanitize_submodule_env()
88{
89044baa 89 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 90 clear_local_git_env
89044baa 91 GIT_CONFIG_PARAMETERS=$save_config
860cba61 92 export GIT_CONFIG_PARAMETERS
14111fc4
JK
93}
94
ecda0723
SV
95#
96# Add a new submodule to the working tree, .gitmodules and the index
97#
ec05df35 98# $@ = repo path
ecda0723
SV
99#
100# optional branch is stored in global branch variable
101#
23a485e3 102cmd_add()
ecda0723 103{
5c08dbbd 104 # parse $args after "submodule ... add".
091a6eb0 105 reference_path=
5c08dbbd
JH
106 while test $# -ne 0
107 do
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
113 ;;
d27b876b
JL
114 -f | --force)
115 force=$1
116 ;;
5c08dbbd 117 -q|--quiet)
2e6a30ef 118 GIT_QUIET=1
5c08dbbd 119 ;;
d92a3959
MT
120 --reference)
121 case "$2" in '') usage ;; esac
091a6eb0 122 reference_path=$2
d92a3959
MT
123 shift
124 ;;
125 --reference=*)
091a6eb0 126 reference_path="${1#--reference=}"
d92a3959 127 ;;
73b0898d
JL
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
132 ;;
275cd184
FG
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
137 ;;
138 --depth=*)
139 depth=$1
140 ;;
5c08dbbd
JH
141 --)
142 shift
143 break
144 ;;
145 -*)
146 usage
147 ;;
148 *)
149 break
150 ;;
151 esac
152 shift
153 done
154
091a6eb0
JK
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
159
160 reference="--reference=$reference_path"
161 fi
162
ecda0723 163 repo=$1
64394e3a 164 sm_path=$2
ecda0723 165
64394e3a 166 if test -z "$sm_path"; then
6a066230 167 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169 fi
170
496eeeb1 171 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
172 usage
173 fi
174
091a6eb0
JK
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
ec05df35
ML
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
091a6eb0
JK
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
ec05df35 183 # dereference source url relative to parent's url
63e95beb 184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
185 ;;
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
189 ;;
190 *)
497ee872 191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
192 ;;
193 esac
194
db75ada5
MG
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
64394e3a 197 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
8196e728 201 s|/\(\./\)*|/|g
db75ada5
MG
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
206 ')
619acfc7
SB
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214 fi
ecda0723 215
53213994
JK
216 if test -z "$force" &&
217 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 218 then
6ff875c5 219 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 220\$sm_path
6ff875c5 221Use -f if you really want to add it." >&2
d27b876b
JL
222 exit 1
223 fi
224
73b0898d
JL
225 if test -n "$custom_name"
226 then
227 sm_name="$custom_name"
228 else
229 sm_name="$sm_path"
230 fi
231
d4264ca3 232 # perhaps the path exists and is already a git repo, else clone it
64394e3a 233 if test -e "$sm_path"
d4264ca3 234 then
496eeeb1 235 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 236 then
64394e3a 237 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 238 else
64394e3a 239 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 240 fi
c2f93917 241
d4264ca3 242 else
4b7c286e
JL
243 if test -d ".git/modules/$sm_name"
244 then
245 if test -z "$force"
246 then
0d71dbfd 247 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 248 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
249 die "$(eval_gettextln "\
250If you want to reuse this local git directory instead of cloning again from
251 \$realrepo
252use the '--force' option. If the local git directory is not the correct repo
253or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 254 else
0d71dbfd 255 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
256 fi
257 fi
d10e3b42 258 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 259 (
14111fc4 260 sanitize_submodule_env
d851ffb9
JH
261 cd "$sm_path" &&
262 # ash fails to wordsplit ${branch:+-b "$branch"...}
263 case "$branch" in
264 '') git checkout -f -q ;;
265 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
266 esac
267 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 268 fi
73b0898d 269 git config submodule."$sm_name".url "$realrepo"
d4264ca3 270
53213994 271 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 272 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 273
73b0898d
JL
274 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
275 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
276 if test -n "$branch"
277 then
278 git config -f .gitmodules submodule."$sm_name".branch "$branch"
279 fi &&
31991b02 280 git add --force .gitmodules ||
64394e3a 281 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
282
283 # NEEDSWORK: In a multi-working-tree world, this needs to be
284 # set in the per-worktree config.
285 if git config --get submodule.active >/dev/null
286 then
287 # If the submodule being adding isn't already covered by the
288 # current configured pathspec, set the submodule's active flag
289 if ! git submodule--helper is-active "$sm_path"
290 then
291 git config submodule."$sm_name".active "true"
292 fi
293 else
294 git config submodule."$sm_name".active "true"
295 fi
ecda0723
SV
296}
297
19a31f9c
ML
298#
299# Execute an arbitrary command sequence in each checked out
300# submodule
301#
302# $@ = command to execute
303#
304cmd_foreach()
305{
1d5bec8b
JH
306 # parse $args after "submodule ... foreach".
307 while test $# -ne 0
308 do
309 case "$1" in
310 -q|--quiet)
311 GIT_QUIET=1
312 ;;
15fc56a8
JH
313 --recursive)
314 recursive=1
315 ;;
1d5bec8b
JH
316 -*)
317 usage
318 ;;
319 *)
320 break
321 ;;
322 esac
323 shift
324 done
325
f030c96d
ÆAB
326 toplevel=$(pwd)
327
4dca1aa6
BC
328 # dup stdin so that it can be restored when running the external
329 # command in the subshell (and a recursive call to this function)
330 exec 3<&0
331
b0f4b408
SB
332 {
333 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 334 echo "#unmatched" $?
b0f4b408 335 } |
cf9e55f4 336 while read -r mode sha1 stage sm_path
19a31f9c 337 do
c4c02bf1 338 die_if_unmatched "$mode" "$sha1"
64394e3a 339 if test -e "$sm_path"/.git
19a31f9c 340 then
44431df0 341 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 342 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 343 name=$(git submodule--helper name "$sm_path")
15fc56a8 344 (
64394e3a 345 prefix="$prefix$sm_path/"
14111fc4 346 sanitize_submodule_env
64394e3a 347 cd "$sm_path" &&
44431df0 348 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
349 # we make $path available to scripts ...
350 path=$sm_path &&
1c4fb136
AK
351 if test $# -eq 1
352 then
353 eval "$1"
354 else
355 "$@"
356 fi &&
15fc56a8
JH
357 if test -n "$recursive"
358 then
359 cmd_foreach "--recursive" "$@"
360 fi
4dca1aa6 361 ) <&3 3<&- ||
ea2fa104 362 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
363 fi
364 done
365}
366
70c7ac22 367#
211b7f19 368# Register submodules in .git/config
70c7ac22
LH
369#
370# $@ = requested paths (default to all)
371#
23a485e3 372cmd_init()
70c7ac22 373{
5c08dbbd
JH
374 # parse $args after "submodule ... init".
375 while test $# -ne 0
376 do
377 case "$1" in
378 -q|--quiet)
2e6a30ef 379 GIT_QUIET=1
5c08dbbd
JH
380 ;;
381 --)
382 shift
383 break
384 ;;
385 -*)
386 usage
387 ;;
388 *)
389 break
390 ;;
391 esac
392 shift
393 done
394
6e7c14e6 395 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
396}
397
cf419828
JL
398#
399# Unregister submodules from .git/config and remove their work tree
400#
cf419828
JL
401cmd_deinit()
402{
403 # parse $args after "submodule ... deinit".
f6a52799 404 deinit_all=
cf419828
JL
405 while test $# -ne 0
406 do
407 case "$1" in
408 -f|--force)
409 force=$1
410 ;;
411 -q|--quiet)
412 GIT_QUIET=1
413 ;;
f6a52799
SB
414 --all)
415 deinit_all=t
416 ;;
cf419828
JL
417 --)
418 shift
419 break
420 ;;
421 -*)
422 usage
423 ;;
424 *)
425 break
426 ;;
427 esac
428 shift
429 done
430
f6a52799
SB
431 if test -n "$deinit_all" && test "$#" -ne 0
432 then
433 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
434 usage
435 fi
436 if test $# = 0 && test -z "$deinit_all"
cf419828 437 then
f6a52799 438 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
439 fi
440
b0f4b408
SB
441 {
442 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 443 echo "#unmatched" $?
b0f4b408 444 } |
cf9e55f4 445 while read -r mode sha1 stage sm_path
cf419828 446 do
c4c02bf1 447 die_if_unmatched "$mode" "$sha1"
0ea306ef 448 name=$(git submodule--helper name "$sm_path") || exit
cf419828 449
44431df0 450 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 451
cf419828
JL
452 # Remove the submodule work tree (unless the user already did it)
453 if test -d "$sm_path"
454 then
455 # Protect submodules containing a .git directory
456 if test -d "$sm_path/.git"
457 then
0d71dbfd
VA
458 die "$(eval_gettext "\
459Submodule work tree '\$displaypath' contains a .git directory
460(use 'rm -rf' if you really want to remove it including all of its history)")"
cf419828
JL
461 fi
462
463 if test -z "$force"
464 then
7b294bf4 465 git rm -qn "$sm_path" ||
091a6eb0 466 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 467 fi
7b294bf4 468 rm -rf "$sm_path" &&
091a6eb0
JK
469 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
470 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
471 fi
472
091a6eb0 473 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
474
475 # Remove the .git/config entries (unless the user already did it)
476 if test -n "$(git config --get-regexp submodule."$name\.")"
477 then
478 # Remove the whole section so we have a clean state when
479 # the user later decides to init this submodule again
480 url=$(git config submodule."$name".url)
481 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 482 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
483 fi
484 done
485}
486
fb43e31f 487is_tip_reachable () (
01e1d544 488 sanitize_submodule_env &&
fb43e31f
SB
489 cd "$1" &&
490 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
491 test -z "$rev"
492)
493
494fetch_in_submodule () (
01e1d544 495 sanitize_submodule_env &&
fb43e31f
SB
496 cd "$1" &&
497 case "$2" in
498 '')
499 git fetch ;;
500 *)
6cbf454a
SB
501 shift
502 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
503 esac
504)
505
70c7ac22 506#
211b7f19 507# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
508#
509# $@ = requested paths (default to all)
510#
23a485e3 511cmd_update()
70c7ac22 512{
5c08dbbd
JH
513 # parse $args after "submodule ... update".
514 while test $# -ne 0
515 do
516 case "$1" in
517 -q|--quiet)
2e6a30ef 518 GIT_QUIET=1
5c08dbbd 519 ;;
72c5f883
JK
520 --progress)
521 progress="--progress"
522 ;;
be4d2c83 523 -i|--init)
d92a3959 524 init=1
be4d2c83 525 ;;
06b1abb5
TK
526 --remote)
527 remote=1
528 ;;
31ca3ac3 529 -N|--no-fetch)
31ca3ac3
FF
530 nofetch=1
531 ;;
9db31bdf
NMC
532 -f|--force)
533 force=$1
534 ;;
ca2cedba 535 -r|--rebase)
32948425 536 update="rebase"
ca2cedba 537 ;;
d92a3959
MT
538 --reference)
539 case "$2" in '') usage ;; esac
540 reference="--reference=$2"
98dbe63d 541 shift
d92a3959
MT
542 ;;
543 --reference=*)
544 reference="$1"
d92a3959 545 ;;
42b49178 546 -m|--merge)
42b49178
JH
547 update="merge"
548 ;;
b13fd5c1 549 --recursive)
b13fd5c1
JH
550 recursive=1
551 ;;
efc5fb6a
JH
552 --checkout)
553 update="checkout"
554 ;;
abed000a
SB
555 --recommend-shallow)
556 recommend_shallow="--recommend-shallow"
557 ;;
558 --no-recommend-shallow)
559 recommend_shallow="--no-recommend-shallow"
560 ;;
275cd184
FG
561 --depth)
562 case "$2" in '') usage ;; esac
563 depth="--depth=$2"
564 shift
565 ;;
566 --depth=*)
567 depth=$1
568 ;;
2335b870
SB
569 -j|--jobs)
570 case "$2" in '') usage ;; esac
571 jobs="--jobs=$2"
572 shift
573 ;;
574 --jobs=*)
575 jobs=$1
576 ;;
5c08dbbd
JH
577 --)
578 shift
579 break
580 ;;
581 -*)
582 usage
583 ;;
584 *)
585 break
586 ;;
587 esac
98dbe63d 588 shift
5c08dbbd
JH
589 done
590
d92a3959
MT
591 if test -n "$init"
592 then
593 cmd_init "--" "$@" || return
594 fi
595
48308681
SB
596 {
597 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
72c5f883 598 ${progress:+"$progress"} \
48308681
SB
599 ${wt_prefix:+--prefix "$wt_prefix"} \
600 ${prefix:+--recursive-prefix "$prefix"} \
601 ${update:+--update "$update"} \
5f50f33e 602 ${reference:+"$reference"} \
48308681 603 ${depth:+--depth "$depth"} \
abed000a 604 ${recommend_shallow:+"$recommend_shallow"} \
2335b870 605 ${jobs:+$jobs} \
c4c02bf1 606 "$@" || echo "#unmatched" $?
48308681 607 } | {
15ffb7cd 608 err=
cf9e55f4 609 while read -r mode sha1 stage just_cloned sm_path
70c7ac22 610 do
c4c02bf1 611 die_if_unmatched "$mode" "$sha1"
48308681 612
0ea306ef 613 name=$(git submodule--helper name "$sm_path") || exit
5be60078 614 url=$(git config submodule."$name".url)
efc5fb6a
JH
615 if ! test -z "$update"
616 then
617 update_module=$update
618 else
619 update_module=$(git config submodule."$name".update)
a2aed08b
TK
620 if test -z "$update_module"
621 then
622 update_module="checkout"
623 fi
efc5fb6a
JH
624 fi
625
44431df0 626 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 627
48308681 628 if test $just_cloned -eq 1
d851ffb9 629 then
bf2d8246 630 subsha1=
e7b37caf
SB
631 case "$update_module" in
632 merge | rebase | none)
633 update_module=checkout ;;
634 esac
bf2d8246 635 else
14111fc4 636 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 637 git rev-parse --verify HEAD) ||
091a6eb0 638 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 639 fi
211b7f19 640
06b1abb5
TK
641 if test -n "$remote"
642 then
92bbe7cc 643 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
644 if test -z "$nofetch"
645 then
646 # Fetch remote before determining tracking $sha1
6cbf454a 647 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
648 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
649 fi
14111fc4
JK
650 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
651 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 652 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 653 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
654 fi
655
496eeeb1 656 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 657 then
9db31bdf
NMC
658 subforce=$force
659 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 660 if test -z "$subsha1" && test -z "$force"
b9b378a0 661 then
9db31bdf 662 subforce="-f"
b9b378a0 663 fi
31ca3ac3
FF
664
665 if test -z "$nofetch"
666 then
e5f522d6
JL
667 # Run fetch only if $sha1 isn't present or it
668 # is not reachable from a ref.
fb43e31f 669 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 670 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 671 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
672
673 # Now we tried the usual fetch, but $sha1 may
674 # not be reachable from any of the refs
675 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 676 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 677 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
678 fi
679
877449c1 680 must_die_on_failure=
32948425 681 case "$update_module" in
a2aed08b
TK
682 checkout)
683 command="git checkout $subforce -q"
684 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
685 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
686 ;;
32948425
JH
687 rebase)
688 command="git rebase"
091a6eb0
JK
689 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
690 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 691 must_die_on_failure=yes
32948425 692 ;;
42b49178
JH
693 merge)
694 command="git merge"
091a6eb0
JK
695 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
696 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 697 must_die_on_failure=yes
42b49178 698 ;;
6cb5728c
CP
699 !*)
700 command="${update_module#!}"
b08238ac
SB
701 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
702 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
703 must_die_on_failure=yes
704 ;;
32948425 705 *)
a2aed08b 706 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 707 esac
70c7ac22 708
14111fc4 709 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 710 then
ff968f03 711 say "$say_msg"
877449c1
JH
712 elif test -n "$must_die_on_failure"
713 then
ff968f03 714 die_with_status 2 "$die_msg"
15ffb7cd 715 else
ff968f03 716 err="${err};$die_msg"
877449c1 717 continue
15ffb7cd 718 fi
70c7ac22 719 fi
b13fd5c1
JH
720
721 if test -n "$recursive"
722 then
75bf5e60 723 (
44431df0 724 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 725 wt_prefix=
14111fc4 726 sanitize_submodule_env
75bf5e60 727 cd "$sm_path" &&
36141282 728 eval cmd_update
75bf5e60 729 )
15ffb7cd
FG
730 res=$?
731 if test $res -gt 0
732 then
091a6eb0 733 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 734 if test $res -ne 2
15ffb7cd 735 then
ff968f03 736 err="${err};$die_msg"
15ffb7cd
FG
737 continue
738 else
ff968f03 739 die_with_status $res "$die_msg"
15ffb7cd
FG
740 fi
741 fi
b13fd5c1 742 fi
70c7ac22 743 done
15ffb7cd
FG
744
745 if test -n "$err"
746 then
747 OIFS=$IFS
748 IFS=';'
749 for e in $err
750 do
751 if test -n "$e"
752 then
753 echo >&2 "$e"
754 fi
755 done
756 IFS=$OIFS
757 exit 1
758 fi
759 }
70c7ac22
LH
760}
761
bffe71f4
EM
762set_name_rev () {
763 revname=$( (
14111fc4 764 sanitize_submodule_env
bffe71f4 765 cd "$1" && {
5be60078
JH
766 git describe "$2" 2>/dev/null ||
767 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
768 git describe --contains "$2" 2>/dev/null ||
769 git describe --all --always "$2"
bffe71f4
EM
770 }
771 ) )
772 test -z "$revname" || revname=" ($revname)"
773}
28f9af5d
PY
774#
775# Show commit summary for submodules in index or working tree
776#
777# If '--cached' is given, show summary between index and given commit,
778# or between working tree and given commit
779#
780# $@ = [commit (default 'HEAD'),] requested paths (default all)
781#
782cmd_summary() {
f2dc06a3 783 summary_limit=-1
d0f64dd4 784 for_status=
1c244f6e 785 diff_cmd=diff-index
f2dc06a3 786
28f9af5d
PY
787 # parse $args after "submodule ... summary".
788 while test $# -ne 0
789 do
790 case "$1" in
791 --cached)
792 cached="$1"
793 ;;
1c244f6e
JL
794 --files)
795 files="$1"
796 ;;
d0f64dd4
PY
797 --for-status)
798 for_status="$1"
799 ;;
f2dc06a3 800 -n|--summary-limit)
862ae6cd
RS
801 summary_limit="$2"
802 isnumber "$summary_limit" || usage
f2dc06a3
PY
803 shift
804 ;;
862ae6cd
RS
805 --summary-limit=*)
806 summary_limit="${1#--summary-limit=}"
807 isnumber "$summary_limit" || usage
808 ;;
28f9af5d
PY
809 --)
810 shift
811 break
812 ;;
813 -*)
814 usage
815 ;;
816 *)
817 break
818 ;;
819 esac
820 shift
821 done
bffe71f4 822
f2dc06a3
PY
823 test $summary_limit = 0 && return
824
3deea89c 825 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
826 then
827 head=$rev
caa9c3ca 828 test $# = 0 || shift
496eeeb1 829 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 830 then
14e940d7
JH
831 # before the first commit: compare with an empty tree
832 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 833 test -z "$1" || shift
28f9af5d 834 else
3deea89c 835 head="HEAD"
28f9af5d
PY
836 fi
837
1c244f6e
JL
838 if [ -n "$files" ]
839 then
840 test -n "$cached" &&
465d6a00 841 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
842 diff_cmd=diff-files
843 head=
844 fi
845
28f9af5d 846 cd_to_toplevel
091a6eb0 847 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 848 # Get modified modules cared by user
18076502 849 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 850 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 851 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
852 do
853 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
854 if test "$status" = D || test "$status" = T
855 then
6a066230 856 printf '%s\n' "$sm_path"
496eeeb1
EP
857 continue
858 fi
927b26f8 859 # Respect the ignore setting for --for-status.
860 if test -n "$for_status"
861 then
0ea306ef 862 name=$(git submodule--helper name "$sm_path")
927b26f8 863 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 864 test $status != A && test $ignore_config = all && continue
927b26f8 865 fi
28f9af5d 866 # Also show added or modified modules which are checked out
2be94509 867 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 868 printf '%s\n' "$sm_path"
28f9af5d
PY
869 done
870 )
1cb639e6 871
d0f64dd4
PY
872 test -z "$modules" && return
873
18076502 874 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 875 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 876 cut -c2- |
cf9e55f4 877 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
878 do
879 if test -z "$cached" &&
880 test $sha1_dst = 0000000000000000000000000000000000000000
881 then
882 case "$mod_dst" in
883 160000)
884 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
885 ;;
886 100644 | 100755 | 120000)
887 sha1_dst=$(git hash-object $name)
888 ;;
889 000000)
890 ;; # removed
891 *)
892 # unexpected type
6ff875c5 893 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
894 continue ;;
895 esac
896 fi
897 missing_src=
898 missing_dst=
899
900 test $mod_src = 160000 &&
30353a40 901 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
902 missing_src=t
903
904 test $mod_dst = 160000 &&
30353a40 905 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 906 missing_dst=t
bffe71f4 907
44431df0 908 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 909
1cb639e6
PY
910 total_commits=
911 case "$missing_src,$missing_dst" in
912 t,)
091a6eb0 913 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
914 ;;
915 ,t)
091a6eb0 916 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
917 ;;
918 t,t)
091a6eb0 919 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
920 ;;
921 *)
922 errmsg=
923 total_commits=$(
496eeeb1 924 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
925 then
926 range="$sha1_src...$sha1_dst"
927 elif test $mod_src = 160000
928 then
929 range=$sha1_src
930 else
931 range=$sha1_dst
932 fi
933 GIT_DIR="$name/.git" \
b0e621ad 934 git rev-list --first-parent $range -- | wc -l
1cb639e6 935 )
eed35595 936 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
937 ;;
938 esac
939
940 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
941 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
942 if test $status = T
943 then
b3e73449
ÆAB
944 blob="$(gettext "blob")"
945 submodule="$(gettext "submodule")"
1cb639e6
PY
946 if test $mod_dst = 160000
947 then
091a6eb0 948 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 949 else
091a6eb0 950 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
951 fi
952 else
091a6eb0 953 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
954 fi
955 if test -n "$errmsg"
956 then
957 # Don't give error msg for modification whose dst is not submodule
958 # i.e. deleted or changed to blob
959 test $mod_dst = 160000 && echo "$errmsg"
960 else
496eeeb1 961 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 962 then
f2dc06a3
PY
963 limit=
964 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 965 GIT_DIR="$name/.git" \
f2dc06a3 966 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
967 --first-parent $sha1_src...$sha1_dst
968 elif test $mod_dst = 160000
969 then
970 GIT_DIR="$name/.git" \
971 git log --pretty='format: > %s' -1 $sha1_dst
972 else
973 GIT_DIR="$name/.git" \
974 git log --pretty='format: < %s' -1 $sha1_src
975 fi
976 echo
977 fi
978 echo
3ba7407b 979 done
28f9af5d 980}
70c7ac22 981#
941987a5 982# List all submodules, prefixed with:
70c7ac22
LH
983# - submodule not initialized
984# + different revision checked out
985#
986# If --cached was specified the revision in the index will be printed
987# instead of the currently checked out revision.
988#
989# $@ = requested paths (default to all)
990#
23a485e3 991cmd_status()
70c7ac22 992{
5c08dbbd
JH
993 # parse $args after "submodule ... status".
994 while test $# -ne 0
995 do
996 case "$1" in
997 -q|--quiet)
2e6a30ef 998 GIT_QUIET=1
5c08dbbd
JH
999 ;;
1000 --cached)
1001 cached=1
1002 ;;
64b19ffe
JH
1003 --recursive)
1004 recursive=1
1005 ;;
5c08dbbd
JH
1006 --)
1007 shift
1008 break
1009 ;;
1010 -*)
1011 usage
1012 ;;
1013 *)
1014 break
1015 ;;
1016 esac
1017 shift
1018 done
1019
b0f4b408
SB
1020 {
1021 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1022 echo "#unmatched" $?
b0f4b408 1023 } |
cf9e55f4 1024 while read -r mode sha1 stage sm_path
70c7ac22 1025 do
c4c02bf1 1026 die_if_unmatched "$mode" "$sha1"
0ea306ef 1027 name=$(git submodule--helper name "$sm_path") || exit
44431df0 1028 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
313ee0d6
NMC
1029 if test "$stage" = U
1030 then
1031 say "U$sha1 $displaypath"
1032 continue
1033 fi
6dc9f01f 1034 if ! git submodule--helper is-active "$sm_path" ||
496eeeb1
EP
1035 {
1036 ! test -d "$sm_path"/.git &&
1037 ! test -f "$sm_path"/.git
1038 }
70c7ac22 1039 then
64b19ffe 1040 say "-$sha1 $displaypath"
70c7ac22
LH
1041 continue;
1042 fi
64394e3a 1043 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1044 then
b545cd15 1045 set_name_rev "$sm_path" "$sha1"
64b19ffe 1046 say " $sha1 $displaypath$revname"
70c7ac22
LH
1047 else
1048 if test -z "$cached"
1049 then
14111fc4 1050 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1051 fi
b545cd15 1052 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1053 say "+$sha1 $displaypath$revname"
1054 fi
1055
1056 if test -n "$recursive"
1057 then
1058 (
1059 prefix="$displaypath/"
14111fc4 1060 sanitize_submodule_env
10450cf7 1061 wt_prefix=
64394e3a 1062 cd "$sm_path" &&
e15bec0e 1063 eval cmd_status
64b19ffe 1064 ) ||
64394e3a 1065 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1066 fi
1067 done
1068}
2327f61e
DA
1069#
1070# Sync remote urls for submodules
1071# This makes the value for remote.$remote.url match the value
1072# specified in .gitmodules.
1073#
1074cmd_sync()
1075{
1076 while test $# -ne 0
1077 do
1078 case "$1" in
1079 -q|--quiet)
2e6a30ef 1080 GIT_QUIET=1
2327f61e
DA
1081 shift
1082 ;;
82f49f29
PH
1083 --recursive)
1084 recursive=1
1085 shift
1086 ;;
2327f61e
DA
1087 --)
1088 shift
1089 break
1090 ;;
1091 -*)
1092 usage
1093 ;;
1094 *)
1095 break
1096 ;;
1097 esac
1098 done
1099 cd_to_toplevel
b0f4b408
SB
1100 {
1101 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1102 echo "#unmatched" $?
b0f4b408 1103 } |
cf9e55f4 1104 while read -r mode sha1 stage sm_path
2327f61e 1105 do
c4c02bf1 1106 die_if_unmatched "$mode" "$sha1"
e7849a96
BW
1107
1108 # skip inactive submodules
25b31f1b 1109 if ! git submodule--helper is-active "$sm_path"
e7849a96
BW
1110 then
1111 continue
1112 fi
1113
25b31f1b 1114 name=$(git submodule--helper name "$sm_path")
2327f61e 1115 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1116
1117 # Possibly a url relative to parent
1118 case "$url" in
1119 ./*|../*)
967b2c66
JS
1120 # rewrite foo/bar as ../.. to find path from
1121 # submodule work tree to superproject work tree
6a066230 1122 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1123 # guarantee a trailing /
1124 up_path=${up_path%/}/ &&
1125 # path from submodule work tree to submodule origin repo
63e95beb 1126 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1127 # path from superproject work tree to submodule origin repo
63e95beb 1128 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1129 ;;
1130 *)
1131 sub_origin_url="$url"
1132 super_config_url="$url"
baede9f8
JH
1133 ;;
1134 esac
1135
e7849a96
BW
1136 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1137 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1138 git config submodule."$name".url "$super_config_url"
1139
1140 if test -e "$sm_path"/.git
2327f61e 1141 then
e7849a96
BW
1142 (
1143 sanitize_submodule_env
1144 cd "$sm_path"
1145 remote=$(get_default_remote)
1146 git config remote."$remote".url "$sub_origin_url"
ccee6086 1147
e7849a96 1148 if test -n "$recursive"
ccee6086 1149 then
e7849a96
BW
1150 prefix="$prefix$sm_path/"
1151 eval cmd_sync
ccee6086 1152 fi
e7849a96 1153 )
2327f61e
DA
1154 fi
1155 done
1156}
70c7ac22 1157
f6f85861
SB
1158cmd_absorbgitdirs()
1159{
1160 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1161}
1162
5c08dbbd
JH
1163# This loop parses the command line arguments to find the
1164# subcommand name to dispatch. Parsing of the subcommand specific
1165# options are primarily done by the subcommand implementations.
1166# Subcommand specific options such as --branch and --cached are
1167# parsed here as well, for backward compatibility.
1168
1169while test $# != 0 && test -z "$command"
70c7ac22
LH
1170do
1171 case "$1" in
f6f85861 1172 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1173 command=$1
70c7ac22
LH
1174 ;;
1175 -q|--quiet)
2e6a30ef 1176 GIT_QUIET=1
70c7ac22 1177 ;;
ecda0723
SV
1178 -b|--branch)
1179 case "$2" in
1180 '')
1181 usage
1182 ;;
1183 esac
1184 branch="$2"; shift
1185 ;;
70c7ac22 1186 --cached)
28f9af5d 1187 cached="$1"
70c7ac22
LH
1188 ;;
1189 --)
1190 break
1191 ;;
1192 -*)
1193 usage
1194 ;;
1195 *)
1196 break
1197 ;;
1198 esac
1199 shift
1200done
1201
5c08dbbd 1202# No command word defaults to "status"
af9c9f97
RR
1203if test -z "$command"
1204then
1205 if test $# = 0
1206 then
1207 command=status
1208 else
1209 usage
1210 fi
1211fi
5c08dbbd
JH
1212
1213# "-b branch" is accepted only by "add"
1214if test -n "$branch" && test "$command" != add
1215then
ecda0723 1216 usage
5c08dbbd
JH
1217fi
1218
28f9af5d 1219# "--cached" is accepted only by "status" and "summary"
496eeeb1 1220if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1221then
70c7ac22 1222 usage
5c08dbbd
JH
1223fi
1224
1225"cmd_$command" "$@"